package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.StrConsultationRecord;
import com.diagbot.service.impl.StrConsultationRecordServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.AStrConsultationRecordVO;
import com.diagbot.vo.data.AStrConsultationNoteVO;
import com.diagbot.vo.data.AStrConsultationResultVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;
@Component
public class AStrConsultationRecordFacade extends StrConsultationRecordServiceImpl {


    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"strConsultationRecord");

        //Map<String, String> map=columnFacade.getColumn("strConsultationNote");
        if(!flag){
            return;
        }
    }

    //会诊记录
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        StrConsultationRecord strConsultationRecord=new StrConsultationRecord();
        try {
            AStrConsultationRecordVO AStrConsultationRecordVO=(AStrConsultationRecordVO) MapUtil.mapToObject(entityMap, AStrConsultationRecordVO.class);
            BeanUtils.copyProperties(AStrConsultationRecordVO,strConsultationRecord);
            strConsultationRecord.setHospitalId(hospitalId);//医院编码

            strConsultationRecord.setRecordDate(DateUtil.parseDateTime(AStrConsultationRecordVO.getRecordDate()));//病历日期recordDate
            strConsultationRecord.setBehospitalDate(DateUtil.parseDateTime(AStrConsultationRecordVO.getBehospitalDate()));//入院日期behospital_date
            strConsultationRecord.setApplyDate(DateUtil.parseDateTime(AStrConsultationRecordVO.getApplyDate()));//申请日期apply_date
            strConsultationRecord.setConsultationDate(DateUtil.parseDate(AStrConsultationRecordVO.getConsultationArriveDate()));//会诊时间consultation_date
            strConsultationRecord.setRecDate(DateUtil.parseDateTime(AStrConsultationRecordVO.getRecDate()));//记录时间rec_date
            strConsultationRecord.setAuditDate(DateUtil.parseDateTime(AStrConsultationRecordVO.getAuditDate()));//审核时间audit_date

            strConsultationRecord.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(strConsultationRecord)){
                strConsultationRecord.setGmtCreate(new Date());//记录创建时间
                this.save(strConsultationRecord);
            }else{
                strConsultationRecord.setGmtModified(new Date());//记录修改时间
                this.update(strConsultationRecord,new QueryWrapper<StrConsultationRecord>()
                        .eq("rec_id", strConsultationRecord.getRecId())
                        .eq("hospital_id", strConsultationRecord.getHospitalId())
                        .eq("behospital_code", strConsultationRecord.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("会诊记录）",strConsultationRecord.getRecId(), JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(StrConsultationRecord strConsultationRecord){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<StrConsultationRecord>()
                .eq("rec_id", strConsultationRecord.getRecId())
                .eq("hospital_id", strConsultationRecord.getHospitalId())
                .eq("behospital_code", strConsultationRecord.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
