package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.StrIllSeriousl;
import com.diagbot.service.impl.StrIllSeriouslServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AStrIllSeriouslVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AStrIllSeriouslFacade extends StrIllSeriouslServiceImpl {

    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"strIllSeriousl");

        //Map<String, String> map=columnFacade.getColumn("strConsultationNote");
        if(!flag){
            return;
        }
    }

    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        StrIllSeriousl strIllSeriousl=new StrIllSeriousl();
        try {
            AStrIllSeriouslVO strIllSeriouslVO=(AStrIllSeriouslVO) MapUtil.mapToObject(entityMap, AStrIllSeriouslVO.class);
            BeanUtils.copyProperties(strIllSeriouslVO,strIllSeriousl);
            strIllSeriousl.setHospitalId(hospitalId);//医院编码
            strIllSeriousl.setPatientSignDate(DateUtil.parseDateTime(strIllSeriouslVO.getPatientSignDate()));
            strIllSeriousl.setDoctorSignDate(DateUtil.parseDateTime(strIllSeriouslVO.getDoctorSignDate()));//审核时间
            strIllSeriousl.setRecordDate(DateUtil.parseDateTime(strIllSeriouslVO.getRecordDate()));//病历日期

            strIllSeriousl.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(strIllSeriousl)){
                strIllSeriousl.setGmtCreate(new Date());//记录创建时间
                this.save(strIllSeriousl);
            }else{
                strIllSeriousl.setGmtModified(new Date());//记录修改时间
                this.update(strIllSeriousl,new QueryWrapper<StrIllSeriousl>()
                        .eq("rec_id", strIllSeriousl.getRecId())
                        .eq("hospital_id", strIllSeriousl.getHospitalId())
                        .eq("behospital_code", strIllSeriousl.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("病重通知单", strIllSeriousl.getRecId(),JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(StrIllSeriousl strIllSeriousl){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<StrIllSeriousl>()
                .eq("rec_id", strIllSeriousl.getRecId())
                .eq("hospital_id", strIllSeriousl.getHospitalId())
                .eq("behospital_code", strIllSeriousl.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
