package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.StrRescueNote;
import com.diagbot.service.impl.StrRescueNoteServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AStrRescueNoteVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AStrRescueNoteFacade extends StrRescueNoteServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"strRescueNote");

        //Map<String, String> map=columnFacade.getColumn("strConsultationNote");
        if(!flag){
            return;
        }
    }

    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        StrRescueNote strRescueNote=new StrRescueNote();
        try {
            AStrRescueNoteVO strRescueNoteVO=(AStrRescueNoteVO) MapUtil.mapToObject(entityMap, AStrRescueNoteVO.class);
            BeanUtils.copyProperties(strRescueNoteVO,strRescueNote);
            strRescueNote.setHospitalId(hospitalId);//医院编码

            strRescueNote.setAuditDate(DateUtil.parseDateTime(strRescueNoteVO.getAuditDate()));//审核时间
            strRescueNote.setRecDate(DateUtil.parseDateTime(strRescueNoteVO.getRecDate()));//记录时间
            strRescueNote.setStartTime(DateUtil.parseDateTime(strRescueNoteVO.getStartTime()));//开始时间
            strRescueNote.setEndTime(DateUtil.parseDate(strRescueNoteVO.getEndTime()));//结束时间
            strRescueNote.setRecordDate(DateUtil.parseDateTime(strRescueNoteVO.getRecordDate()));//病历日期

            strRescueNote.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(strRescueNote)){
                strRescueNote.setGmtCreate(new Date());//记录创建时间
                this.save(strRescueNote);
            }else{
                strRescueNote.setGmtModified(new Date());//记录修改时间
                this.update(strRescueNote,new QueryWrapper<StrRescueNote>()
                        .eq("rec_id", strRescueNote.getRecId())
                        .eq("hospital_id", strRescueNote.getHospitalId())
                        .eq("behospital_code", strRescueNote.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("抢救记录", strRescueNote.getRecId(),JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(StrRescueNote strRescueNote){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<StrRescueNote>()
                .eq("rec_id", strRescueNote.getRecId())
                .eq("hospital_id", strRescueNote.getHospitalId())
                .eq("behospital_code", strRescueNote.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
